/* list.h */
/* $Id: modbus.h 18 2004-12-08 10:28:05Z rsc $ */
/* ... */

#ifndef MODBUS_H
# define MODBUS_H
# ifdef __cplusplus
extern "C" 
{
# endif

#include <netinet/in.h>
#include <arpa/inet.h>

/* Which Modbus variant do we have? */
enum modbus_type {
	MODBUS_TCP,
};


/* Function Codes */
#define FKT_R_COILS		0x01
#define FKT_R_DISCRETE_IN	0x02
#define FKT_R_HOLDING_REG	0x03
#define FKT_R_INPUT_REG		0x04
#define FKT_W_SINGLE_COIL	0x05
#define FKT_W_SINGLE_REG	0x06
#define FKT_R_EXEPTTION_STAT	0x07
#define FKT_DIAGNOSTICS		0x08

/* A Modbus Device */
typedef struct {
	enum modbus_type        type;           /* MODBUS_TCP, ... */
	char                    *host;          /* for tcp         */
	int                     in_socket_fd;   /* socket for tcp  */
	struct sockaddr_in	in_address;     /* inet address    */
} modbus_dev_t;

/* API */
int modbus_w_single_coil(modbus_dev_t *dev, int coil, int value);

# ifdef __cplusplus
}
# endif
#endif /* MODBUS_H */
